

;--------------   MAKE YOUR SELECTIONS  !!!!!   ------------------------------------


;Select the Timer to be used as Baud Rate Generator 

COM_BRG			EQU	1	;select Timer 1 as baud rate generator
;COM_BRG		EQU	2	;select Timer 2 as baud rate generator



;Select Reload Value from appropriate table at the bottom and insert it
;after the EQU

COM_RV			EQU	-3	;<<--- insert reload value here



;if you use Timer 1 and the table entry includes "SMOD=1", select this line

COM_SMOD		EQU	1

;else select this line

;COM_SMOD		EQU	0
	


;--------------   CALL "com_init" TO MAKE YOUR SERIAL PORT RUNNING   -----------------------------


com_init:		mov C, EA			;save status of EA
			clr EA				;disable all Ints
			clr ES				;serial port in polling mode, no ints
						
IF (COM_BRG = 1);using Timer 1 as baud rate generator
			
			clr TR1				;stop Timer 1
			clr ET1				;disable Timer 1 Ints
			clr TF1 			;clear pending Timer 1 Ints
			clr RCLK			;receive baud rate source is Timer 1
			clr TCLK			;transmit baud rate source is Timer 1
			anl TMOD, #00fh			;Timer 1: 8-bit auto reload timer, not gated
			orl TMOD, #020h
			mov TL1, # COM_RV		;reload value (initial)
			mov TH1, # COM_RV		;reload value

	IF (COM_SMOD = 1)
			orl PCON, # _SMOD		;doubled baud rate 
	ELSE				
			anl PCON, # NOT (_SMOD)		;not doubled baud rate
	ENDIF

			mov SCON, #042h			;8-bit UART, single processor
			setb TR1			;start Timer 1



ELSE ;(COM_BRG = 2)	using Timer 2 as baud rate generator
						

			clr TR2				;stop Timer 2
			clr CNT2			;Timer 2 driven by oscillator
			setb RCLK			;receive baud rate source is Timer 2
			setb TCLK			;transmit baud rate source is Timer 2
			anl T2MOD, # NOT (_DCEN)	;default count up Timer 2

			mov TH2, # HIGH (COM_RV)	;reload value high byte (initial)
			mov RCAP2H, # HIGH (COM_RV)	;reload value high byte
			mov TL2, # LOW (COM_RV)		;reload value low byte (initial)
			mov RCAP2L, # LOW (COM_RV) 	;reload value low byte

			mov SCON, #042h			;8-bit UART, single processor
			setb TR2			;start Timer 1


ENDIF

			setb TI				;transmitter empty
			clr RI				;receiver empty
			setb REN			;enable receicer
			mov EA, C			;restore status of EA



; Timer 1 as baud rate generator: select appropriate value
; ------- 

;			oscillator frequency ->
;baud rate
;	|
;	V
;		 3.686400	 7.372800	11.059200	14.745600	22.118400

;  2400		    -4		    -8		    -12		    -16		    -24

;  4800		    -2		    -4		    -6		    -8		    -12

;  9600		    -1		    -2		    -3		    -4		    -6

; 19200		-1 SMOD=1	    -1		-3 SMOD=1	    -2		    -3

; 38400		   ---		-1 SMOD=1	   ---		    -1		-3 SMOD=1

; 57600		   ---		   ---		   ---		-1 SMOD=1	    -1

;115200		   ---		   ---		   ---		   ---		-1 SMOD=1






; Timer 2 as baud rate generator: select appropriate value
; -------

;			oscillator frequency ->
;baud rate
;	|
;	V
;		 3.686400	 7.372800	11.059200	14.745600	22.118400

;  2400		    -48		    -96		    -144	    -192	    -288

;  4800		    -24		    -48		    -72		    -96		    -144

;  9600		    -12		    -24		    -36		    -48		    -72

; 19200		    -6		    -12		    -18		    -24		    -36

; 38400		    -3		    -6		    -9		    -12		    -18

; 57600		    -2		    -4		    -6		    -8		    -12

;115200		    -1		    -2		    -3		    -4		    -6




